<html>
<head>
<title>Ogre::TerrainMaterialGeneratorA::SM2Profile::ShaderHelper Class Reference - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li class="current"><a href="annotated.html"><span>Classes</span></a></li>
      <li><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="annotated.html"><span>Class&#160;List</span></a></li>
      <li><a href="classes.html"><span>Class&#160;Index</span></a></li>
      <li><a href="inherits.html"><span>Class&#160;Hierarchy</span></a></li>
      <li><a href="functions.html"><span>Class&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="namespaceOgre.html">Ogre</a>      </li>
      <li class="navelem"><a class="el" href="classOgre_1_1TerrainMaterialGeneratorA.html">TerrainMaterialGeneratorA</a>      </li>
      <li class="navelem"><a class="el" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile.html">SM2Profile</a>      </li>
      <li class="navelem"><a class="el" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile_1_1ShaderHelper.html">ShaderHelper</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="summary">
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="#pro-methods">Protected Member Functions</a> &#124;
<a href="#pro-static-methods">Static Protected Member Functions</a> &#124;
<a href="#pro-attribs">Protected Attributes</a>  </div>
  <div class="headertitle">
<div class="title">Ogre::TerrainMaterialGeneratorA::SM2Profile::ShaderHelper Class Reference</div>  </div>
</div><!--header-->
<div class="contents">
<!-- doxytag: class="Ogre::TerrainMaterialGeneratorA::SM2Profile::ShaderHelper" --><!-- doxytag: inherits="Ogre::AllocatedObject" -->
<p>Interface definition for helper class to generate shaders.  
 <a href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile_1_1ShaderHelper.html#details">More...</a></p>

<p><code>#include &lt;<a class="el" href="OgreTerrainMaterialGeneratorA_8h_source.html">OgreTerrainMaterialGeneratorA.h</a>&gt;</code></p>
<div class="dynheader">
Inheritance diagram for Ogre::TerrainMaterialGeneratorA::SM2Profile::ShaderHelper:</div>
<div class="dyncontent">
<div class="center"><img src="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile_1_1ShaderHelper__inherit__graph.gif" border="0" usemap="#Ogre_1_1TerrainMaterialGeneratorA_1_1SM2Profile_1_1ShaderHelper_inherit__map" alt="Inheritance graph"/></div>
<map name="Ogre_1_1TerrainMaterialGeneratorA_1_1SM2Profile_1_1ShaderHelper_inherit__map" id="Ogre_1_1TerrainMaterialGeneratorA_1_1SM2Profile_1_1ShaderHelper_inherit__map">
<area shape="rect" id="node5" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile_1_1ShaderHelperCg.html" title="Utility class to help with generating shaders for Cg / HLSL." alt="" coords="580,5,967,35"/><area shape="rect" id="node9" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile_1_1ShaderHelperGLSL.html" title="Utility class to help with generating shaders for GLSL." alt="" coords="572,59,975,88"/><area shape="rect" id="node11" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile_1_1ShaderHelperGLSLES.html" title="Utility class to help with generating shaders for GLSL ES." alt="" coords="564,112,983,141"/><area shape="rect" id="node2" href="classOgre_1_1AllocatedObject.html" title="Superclass for all objects that wish to use custom memory allocators when their new / delete operator..." alt="" coords="5,59,96,88"/><area shape="rect" id="node7" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile_1_1ShaderHelperHLSL.html" title="Ogre::TerrainMaterialGeneratorA::SM2Profile::ShaderHelperHLSL" alt="" coords="1032,5,1435,35"/></map>
<center><span class="legend">[<a href="graph_legend.html">legend</a>]</span></center></div>

<p><a href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile_1_1ShaderHelper-members.html">List of all members.</a></p>
<table class="memberdecls">
<tr><td colspan="2"><h2><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile_1_1ShaderHelper.html#ac76120b3aa747d1f2adbe9e2fc374be1">ShaderHelper</a> ()</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile_1_1ShaderHelper.html#a28ad3f6af71a8b65f4af872f15e5a0a1">~ShaderHelper</a> ()</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual <a class="el" href="classOgre_1_1HighLevelGpuProgramPtr.html">HighLevelGpuProgramPtr</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile_1_1ShaderHelper.html#a5b6c717ef1de61420e09f8672d8ff7b1">generateVertexProgram</a> (const <a class="el" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile.html">SM2Profile</a> *prof, const <a class="el" href="classOgre_1_1Terrain.html">Terrain</a> *terrain, <a class="el" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile.html#a626162178bf4831bcdc1a5138e5772c6">TechniqueType</a> tt)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual <a class="el" href="classOgre_1_1HighLevelGpuProgramPtr.html">HighLevelGpuProgramPtr</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile_1_1ShaderHelper.html#a2d7a0d872046ca6724f02e1262b70b73">generateFragmentProgram</a> (const <a class="el" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile.html">SM2Profile</a> *prof, const <a class="el" href="classOgre_1_1Terrain.html">Terrain</a> *terrain, <a class="el" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile.html#a626162178bf4831bcdc1a5138e5772c6">TechniqueType</a> tt)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile_1_1ShaderHelper.html#a89278834abece5ce1bf66a0b7ecc9f05">updateParams</a> (const <a class="el" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile.html">SM2Profile</a> *prof, const <a class="el" href="classOgre_1_1MaterialPtr.html">MaterialPtr</a> &amp;mat, const <a class="el" href="classOgre_1_1Terrain.html">Terrain</a> *terrain, bool compositeMap)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AllocatedObject.html#a421b197ca3a38da17e2eb1531a645fa2">operator new</a> (size_t sz, const char *file, int line, const char *func)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">operator new, with debug line info  <a href="#a421b197ca3a38da17e2eb1531a645fa2"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AllocatedObject.html#ac4bdf968b7b9af8a5239a27da73d5711">operator new</a> (size_t sz)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AllocatedObject.html#ab78a921e54419be677839cdf15d1f0b8">operator new</a> (size_t sz, void *ptr)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">placement operator new  <a href="#ab78a921e54419be677839cdf15d1f0b8"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AllocatedObject.html#a4be37baef81876985aa1071ad5acc6dd">operator new[]</a> (size_t sz, const char *file, int line, const char *func)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">array operator new, with debug line info  <a href="#a4be37baef81876985aa1071ad5acc6dd"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AllocatedObject.html#afa2943846ba6a2b5824a12857139cf5e">operator new[]</a> (size_t sz)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AllocatedObject.html#a8357fe4fb4849772b94baa4bf47c7ded">operator delete</a> (void *ptr)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AllocatedObject.html#a1c727e879a260c37b00ce5505fe8e144">operator delete</a> (void *ptr, void *)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AllocatedObject.html#acb46d4b0a597156d9ba5abc39d127792">operator delete</a> (void *ptr, const char *, int, const char *)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AllocatedObject.html#a93e6a86dde5483c053ca0f2a85bbfd6c">operator delete[]</a> (void *ptr)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AllocatedObject.html#a595ea4c05da8aa987d3800e65d23355d">operator delete[]</a> (void *ptr, const char *, int, const char *)</td></tr>
<tr><td colspan="2"><h2><a name="pro-methods"></a>
Protected Member Functions</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual <a class="el" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile_1_1ShaderHelper.html#a7766b57d1f02d8678a3c3157c48f8125">getVertexProgramName</a> (const <a class="el" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile.html">SM2Profile</a> *prof, const <a class="el" href="classOgre_1_1Terrain.html">Terrain</a> *terrain, <a class="el" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile.html#a626162178bf4831bcdc1a5138e5772c6">TechniqueType</a> tt)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual <a class="el" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile_1_1ShaderHelper.html#a51da01d67dd1583b065aedb8f490a77f">getFragmentProgramName</a> (const <a class="el" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile.html">SM2Profile</a> *prof, const <a class="el" href="classOgre_1_1Terrain.html">Terrain</a> *terrain, <a class="el" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile.html#a626162178bf4831bcdc1a5138e5772c6">TechniqueType</a> tt)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual <a class="el" href="classOgre_1_1HighLevelGpuProgramPtr.html">HighLevelGpuProgramPtr</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile_1_1ShaderHelper.html#a24a6dbd7d64220747b2c4150a930afba">createVertexProgram</a> (const <a class="el" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile.html">SM2Profile</a> *prof, const <a class="el" href="classOgre_1_1Terrain.html">Terrain</a> *terrain, <a class="el" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile.html#a626162178bf4831bcdc1a5138e5772c6">TechniqueType</a> tt)=0</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual <a class="el" href="classOgre_1_1HighLevelGpuProgramPtr.html">HighLevelGpuProgramPtr</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile_1_1ShaderHelper.html#a7d874afcba11cbd62917f338ed1e058c">createFragmentProgram</a> (const <a class="el" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile.html">SM2Profile</a> *prof, const <a class="el" href="classOgre_1_1Terrain.html">Terrain</a> *terrain, <a class="el" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile.html#a626162178bf4831bcdc1a5138e5772c6">TechniqueType</a> tt)=0</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile_1_1ShaderHelper.html#adb93f316855750ce168edd01085c407b">generateVertexProgramSource</a> (const <a class="el" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile.html">SM2Profile</a> *prof, const <a class="el" href="classOgre_1_1Terrain.html">Terrain</a> *terrain, <a class="el" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile.html#a626162178bf4831bcdc1a5138e5772c6">TechniqueType</a> tt, <a class="el" href="classOgre_1_1StringUtil.html#a665d79932d54b48b83acff563de7a9e5">StringUtil::StrStreamType</a> &amp;outStream)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile_1_1ShaderHelper.html#a051a9e289d9483f70bea14ea9d14641a">generateFragmentProgramSource</a> (const <a class="el" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile.html">SM2Profile</a> *prof, const <a class="el" href="classOgre_1_1Terrain.html">Terrain</a> *terrain, <a class="el" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile.html#a626162178bf4831bcdc1a5138e5772c6">TechniqueType</a> tt, <a class="el" href="classOgre_1_1StringUtil.html#a665d79932d54b48b83acff563de7a9e5">StringUtil::StrStreamType</a> &amp;outStream)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile_1_1ShaderHelper.html#a8592db72e31a98936f251b2d4bc8b107">generateVpHeader</a> (const <a class="el" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile.html">SM2Profile</a> *prof, const <a class="el" href="classOgre_1_1Terrain.html">Terrain</a> *terrain, <a class="el" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile.html#a626162178bf4831bcdc1a5138e5772c6">TechniqueType</a> tt, <a class="el" href="classOgre_1_1StringUtil.html#a665d79932d54b48b83acff563de7a9e5">StringUtil::StrStreamType</a> &amp;outStream)=0</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile_1_1ShaderHelper.html#a8342a7ab38996817b5edfefd48f78e72">generateFpHeader</a> (const <a class="el" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile.html">SM2Profile</a> *prof, const <a class="el" href="classOgre_1_1Terrain.html">Terrain</a> *terrain, <a class="el" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile.html#a626162178bf4831bcdc1a5138e5772c6">TechniqueType</a> tt, <a class="el" href="classOgre_1_1StringUtil.html#a665d79932d54b48b83acff563de7a9e5">StringUtil::StrStreamType</a> &amp;outStream)=0</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile_1_1ShaderHelper.html#a05053b390eb85adeb67b2f5e231fb757">generateVpLayer</a> (const <a class="el" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile.html">SM2Profile</a> *prof, const <a class="el" href="classOgre_1_1Terrain.html">Terrain</a> *terrain, <a class="el" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile.html#a626162178bf4831bcdc1a5138e5772c6">TechniqueType</a> tt, <a class="el" href="namespaceOgre.html#ab6e842a18caf062ed73a5d3badd0dd4c">uint</a> layer, <a class="el" href="classOgre_1_1StringUtil.html#a665d79932d54b48b83acff563de7a9e5">StringUtil::StrStreamType</a> &amp;outStream)=0</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile_1_1ShaderHelper.html#ab9327ddc0ae1d7123786bba0289005e7">generateFpLayer</a> (const <a class="el" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile.html">SM2Profile</a> *prof, const <a class="el" href="classOgre_1_1Terrain.html">Terrain</a> *terrain, <a class="el" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile.html#a626162178bf4831bcdc1a5138e5772c6">TechniqueType</a> tt, <a class="el" href="namespaceOgre.html#ab6e842a18caf062ed73a5d3badd0dd4c">uint</a> layer, <a class="el" href="classOgre_1_1StringUtil.html#a665d79932d54b48b83acff563de7a9e5">StringUtil::StrStreamType</a> &amp;outStream)=0</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile_1_1ShaderHelper.html#a603958e286a7416fe331b48b835984db">generateVpFooter</a> (const <a class="el" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile.html">SM2Profile</a> *prof, const <a class="el" href="classOgre_1_1Terrain.html">Terrain</a> *terrain, <a class="el" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile.html#a626162178bf4831bcdc1a5138e5772c6">TechniqueType</a> tt, <a class="el" href="classOgre_1_1StringUtil.html#a665d79932d54b48b83acff563de7a9e5">StringUtil::StrStreamType</a> &amp;outStream)=0</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile_1_1ShaderHelper.html#a0fce89d5ab80a86fe1df86c7cb232c66">generateFpFooter</a> (const <a class="el" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile.html">SM2Profile</a> *prof, const <a class="el" href="classOgre_1_1Terrain.html">Terrain</a> *terrain, <a class="el" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile.html#a626162178bf4831bcdc1a5138e5772c6">TechniqueType</a> tt, <a class="el" href="classOgre_1_1StringUtil.html#a665d79932d54b48b83acff563de7a9e5">StringUtil::StrStreamType</a> &amp;outStream)=0</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile_1_1ShaderHelper.html#aa8dd17e16d7976ec6c7388d34d224a99">defaultVpParams</a> (const <a class="el" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile.html">SM2Profile</a> *prof, const <a class="el" href="classOgre_1_1Terrain.html">Terrain</a> *terrain, <a class="el" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile.html#a626162178bf4831bcdc1a5138e5772c6">TechniqueType</a> tt, const <a class="el" href="classOgre_1_1HighLevelGpuProgramPtr.html">HighLevelGpuProgramPtr</a> &amp;prog)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile_1_1ShaderHelper.html#a38d0b9b75c1fe681bcf5dd82eb875ae7">defaultFpParams</a> (const <a class="el" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile.html">SM2Profile</a> *prof, const <a class="el" href="classOgre_1_1Terrain.html">Terrain</a> *terrain, <a class="el" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile.html#a626162178bf4831bcdc1a5138e5772c6">TechniqueType</a> tt, const <a class="el" href="classOgre_1_1HighLevelGpuProgramPtr.html">HighLevelGpuProgramPtr</a> &amp;prog)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile_1_1ShaderHelper.html#a424cd62f696d63da60cea51f03579e84">updateVpParams</a> (const <a class="el" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile.html">SM2Profile</a> *prof, const <a class="el" href="classOgre_1_1Terrain.html">Terrain</a> *terrain, <a class="el" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile.html#a626162178bf4831bcdc1a5138e5772c6">TechniqueType</a> tt, const <a class="el" href="group__Materials.html#gaebab7cecf3f3ae81a1fbfa08ab36f2b5">GpuProgramParametersSharedPtr</a> &amp;params)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile_1_1ShaderHelper.html#a85c467fe1d437ab15d8ab52a7b7b1a4f">updateFpParams</a> (const <a class="el" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile.html">SM2Profile</a> *prof, const <a class="el" href="classOgre_1_1Terrain.html">Terrain</a> *terrain, <a class="el" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile.html#a626162178bf4831bcdc1a5138e5772c6">TechniqueType</a> tt, const <a class="el" href="group__Materials.html#gaebab7cecf3f3ae81a1fbfa08ab36f2b5">GpuProgramParametersSharedPtr</a> &amp;params)</td></tr>
<tr><td colspan="2"><h2><a name="pro-static-methods"></a>
Static Protected Member Functions</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">static <a class="el" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile_1_1ShaderHelper.html#abe43c3f90310fb32c71bc6d53458e405">getChannel</a> (<a class="el" href="namespaceOgre.html#ab6e842a18caf062ed73a5d3badd0dd4c">uint</a> idx)</td></tr>
<tr><td colspan="2"><h2><a name="pro-attribs"></a>
Protected Attributes</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">size_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile_1_1ShaderHelper.html#a517f480f42d873878c2ffe3ef464afb7">mShadowSamplerStartHi</a></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">size_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile_1_1ShaderHelper.html#adf1108ee4e3b76d105732210ccf4ff51">mShadowSamplerStartLo</a></td></tr>
</table>
<hr/><a name="details" id="details"></a><h2>Detailed Description</h2>
<div class="textblock"><p>Interface definition for helper class to generate shaders. </p>

<p>Definition at line <a class="el" href="OgreTerrainMaterialGeneratorA_8h_source.html#l00161">161</a> of file <a class="el" href="OgreTerrainMaterialGeneratorA_8h_source.html">OgreTerrainMaterialGeneratorA.h</a>.</p>
</div><hr/><h2>Constructor &amp; Destructor Documentation</h2>
<a class="anchor" id="ac76120b3aa747d1f2adbe9e2fc374be1"></a><!-- doxytag: member="Ogre::TerrainMaterialGeneratorA::SM2Profile::ShaderHelper::ShaderHelper" ref="ac76120b3aa747d1f2adbe9e2fc374be1" args="()" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile_1_1ShaderHelper.html#ac76120b3aa747d1f2adbe9e2fc374be1">Ogre::TerrainMaterialGeneratorA::SM2Profile::ShaderHelper::ShaderHelper</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreTerrainMaterialGeneratorA_8h_source.html#l00164">164</a> of file <a class="el" href="OgreTerrainMaterialGeneratorA_8h_source.html">OgreTerrainMaterialGeneratorA.h</a>.</p>

</div>
</div>
<a class="anchor" id="a28ad3f6af71a8b65f4af872f15e5a0a1"></a><!-- doxytag: member="Ogre::TerrainMaterialGeneratorA::SM2Profile::ShaderHelper::~ShaderHelper" ref="a28ad3f6af71a8b65f4af872f15e5a0a1" args="()" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual <a class="el" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile_1_1ShaderHelper.html#a28ad3f6af71a8b65f4af872f15e5a0a1">Ogre::TerrainMaterialGeneratorA::SM2Profile::ShaderHelper::~ShaderHelper</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td><code> [virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreTerrainMaterialGeneratorA_8h_source.html#l00165">165</a> of file <a class="el" href="OgreTerrainMaterialGeneratorA_8h_source.html">OgreTerrainMaterialGeneratorA.h</a>.</p>

</div>
</div>
<hr/><h2>Member Function Documentation</h2>
<a class="anchor" id="a7d874afcba11cbd62917f338ed1e058c"></a><!-- doxytag: member="Ogre::TerrainMaterialGeneratorA::SM2Profile::ShaderHelper::createFragmentProgram" ref="a7d874afcba11cbd62917f338ed1e058c" args="(const SM2Profile *prof, const Terrain *terrain, TechniqueType tt)=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual <a class="el" href="classOgre_1_1HighLevelGpuProgramPtr.html">HighLevelGpuProgramPtr</a> <a class="el" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile_1_1ShaderHelper.html#a7d874afcba11cbd62917f338ed1e058c">Ogre::TerrainMaterialGeneratorA::SM2Profile::ShaderHelper::createFragmentProgram</a> </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile.html">SM2Profile</a> *&#160;</td>
          <td class="paramname"><em>prof</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1Terrain.html">Terrain</a> *&#160;</td>
          <td class="paramname"><em>terrain</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile.html#a626162178bf4831bcdc1a5138e5772c6">TechniqueType</a>&#160;</td>
          <td class="paramname"><em>tt</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [protected, pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Implemented in <a class="el" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile_1_1ShaderHelperGLSLES.html#a1350f7cb95ae7c39457b92600d49ba2a">Ogre::TerrainMaterialGeneratorA::SM2Profile::ShaderHelperGLSLES</a>, <a class="el" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile_1_1ShaderHelperGLSL.html#a1b92e46c8f430b1ea6753efa24cfd8f7">Ogre::TerrainMaterialGeneratorA::SM2Profile::ShaderHelperGLSL</a>, <a class="el" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile_1_1ShaderHelperHLSL.html#ab1203d67df3125f1f226a46e36b78123">Ogre::TerrainMaterialGeneratorA::SM2Profile::ShaderHelperHLSL</a>, and <a class="el" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile_1_1ShaderHelperCg.html#a19129d260a4fe39ae371232d3afa2f42">Ogre::TerrainMaterialGeneratorA::SM2Profile::ShaderHelperCg</a>.</p>

</div>
</div>
<a class="anchor" id="a24a6dbd7d64220747b2c4150a930afba"></a><!-- doxytag: member="Ogre::TerrainMaterialGeneratorA::SM2Profile::ShaderHelper::createVertexProgram" ref="a24a6dbd7d64220747b2c4150a930afba" args="(const SM2Profile *prof, const Terrain *terrain, TechniqueType tt)=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual <a class="el" href="classOgre_1_1HighLevelGpuProgramPtr.html">HighLevelGpuProgramPtr</a> <a class="el" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile_1_1ShaderHelper.html#a24a6dbd7d64220747b2c4150a930afba">Ogre::TerrainMaterialGeneratorA::SM2Profile::ShaderHelper::createVertexProgram</a> </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile.html">SM2Profile</a> *&#160;</td>
          <td class="paramname"><em>prof</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1Terrain.html">Terrain</a> *&#160;</td>
          <td class="paramname"><em>terrain</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile.html#a626162178bf4831bcdc1a5138e5772c6">TechniqueType</a>&#160;</td>
          <td class="paramname"><em>tt</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [protected, pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Implemented in <a class="el" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile_1_1ShaderHelperGLSLES.html#a8fbb9a15d6e270b89514abfa8ab84e94">Ogre::TerrainMaterialGeneratorA::SM2Profile::ShaderHelperGLSLES</a>, <a class="el" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile_1_1ShaderHelperGLSL.html#acd57fbe7ca2b90461b7f4f183c0d2ee3">Ogre::TerrainMaterialGeneratorA::SM2Profile::ShaderHelperGLSL</a>, <a class="el" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile_1_1ShaderHelperHLSL.html#a4031c7198fdeffafb95d8216cfa9f280">Ogre::TerrainMaterialGeneratorA::SM2Profile::ShaderHelperHLSL</a>, and <a class="el" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile_1_1ShaderHelperCg.html#a5d09c14548dd2e9fee7b169644df3e59">Ogre::TerrainMaterialGeneratorA::SM2Profile::ShaderHelperCg</a>.</p>

</div>
</div>
<a class="anchor" id="a38d0b9b75c1fe681bcf5dd82eb875ae7"></a><!-- doxytag: member="Ogre::TerrainMaterialGeneratorA::SM2Profile::ShaderHelper::defaultFpParams" ref="a38d0b9b75c1fe681bcf5dd82eb875ae7" args="(const SM2Profile *prof, const Terrain *terrain, TechniqueType tt, const HighLevelGpuProgramPtr &amp;prog)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile_1_1ShaderHelper.html#a38d0b9b75c1fe681bcf5dd82eb875ae7">Ogre::TerrainMaterialGeneratorA::SM2Profile::ShaderHelper::defaultFpParams</a> </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile.html">SM2Profile</a> *&#160;</td>
          <td class="paramname"><em>prof</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1Terrain.html">Terrain</a> *&#160;</td>
          <td class="paramname"><em>terrain</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile.html#a626162178bf4831bcdc1a5138e5772c6">TechniqueType</a>&#160;</td>
          <td class="paramname"><em>tt</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1HighLevelGpuProgramPtr.html">HighLevelGpuProgramPtr</a> &amp;&#160;</td>
          <td class="paramname"><em>prog</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [protected, virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

</div>
</div>
<a class="anchor" id="aa8dd17e16d7976ec6c7388d34d224a99"></a><!-- doxytag: member="Ogre::TerrainMaterialGeneratorA::SM2Profile::ShaderHelper::defaultVpParams" ref="aa8dd17e16d7976ec6c7388d34d224a99" args="(const SM2Profile *prof, const Terrain *terrain, TechniqueType tt, const HighLevelGpuProgramPtr &amp;prog)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile_1_1ShaderHelper.html#aa8dd17e16d7976ec6c7388d34d224a99">Ogre::TerrainMaterialGeneratorA::SM2Profile::ShaderHelper::defaultVpParams</a> </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile.html">SM2Profile</a> *&#160;</td>
          <td class="paramname"><em>prof</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1Terrain.html">Terrain</a> *&#160;</td>
          <td class="paramname"><em>terrain</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile.html#a626162178bf4831bcdc1a5138e5772c6">TechniqueType</a>&#160;</td>
          <td class="paramname"><em>tt</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1HighLevelGpuProgramPtr.html">HighLevelGpuProgramPtr</a> &amp;&#160;</td>
          <td class="paramname"><em>prog</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [protected, virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

</div>
</div>
<a class="anchor" id="a0fce89d5ab80a86fe1df86c7cb232c66"></a><!-- doxytag: member="Ogre::TerrainMaterialGeneratorA::SM2Profile::ShaderHelper::generateFpFooter" ref="a0fce89d5ab80a86fe1df86c7cb232c66" args="(const SM2Profile *prof, const Terrain *terrain, TechniqueType tt, StringUtil::StrStreamType &amp;outStream)=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile_1_1ShaderHelper.html#a0fce89d5ab80a86fe1df86c7cb232c66">Ogre::TerrainMaterialGeneratorA::SM2Profile::ShaderHelper::generateFpFooter</a> </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile.html">SM2Profile</a> *&#160;</td>
          <td class="paramname"><em>prof</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1Terrain.html">Terrain</a> *&#160;</td>
          <td class="paramname"><em>terrain</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile.html#a626162178bf4831bcdc1a5138e5772c6">TechniqueType</a>&#160;</td>
          <td class="paramname"><em>tt</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="classOgre_1_1StringUtil.html#a665d79932d54b48b83acff563de7a9e5">StringUtil::StrStreamType</a> &amp;&#160;</td>
          <td class="paramname"><em>outStream</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [protected, pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Implemented in <a class="el" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile_1_1ShaderHelperGLSLES.html#a152be5e7994924fdeb1072885f95d55a">Ogre::TerrainMaterialGeneratorA::SM2Profile::ShaderHelperGLSLES</a>, <a class="el" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile_1_1ShaderHelperGLSL.html#a1b01e08ebcd6fe459aa620dd097b2c41">Ogre::TerrainMaterialGeneratorA::SM2Profile::ShaderHelperGLSL</a>, and <a class="el" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile_1_1ShaderHelperCg.html#a07167bb30592eb412d6866c3e9af47f9">Ogre::TerrainMaterialGeneratorA::SM2Profile::ShaderHelperCg</a>.</p>

</div>
</div>
<a class="anchor" id="a8342a7ab38996817b5edfefd48f78e72"></a><!-- doxytag: member="Ogre::TerrainMaterialGeneratorA::SM2Profile::ShaderHelper::generateFpHeader" ref="a8342a7ab38996817b5edfefd48f78e72" args="(const SM2Profile *prof, const Terrain *terrain, TechniqueType tt, StringUtil::StrStreamType &amp;outStream)=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile_1_1ShaderHelper.html#a8342a7ab38996817b5edfefd48f78e72">Ogre::TerrainMaterialGeneratorA::SM2Profile::ShaderHelper::generateFpHeader</a> </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile.html">SM2Profile</a> *&#160;</td>
          <td class="paramname"><em>prof</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1Terrain.html">Terrain</a> *&#160;</td>
          <td class="paramname"><em>terrain</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile.html#a626162178bf4831bcdc1a5138e5772c6">TechniqueType</a>&#160;</td>
          <td class="paramname"><em>tt</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="classOgre_1_1StringUtil.html#a665d79932d54b48b83acff563de7a9e5">StringUtil::StrStreamType</a> &amp;&#160;</td>
          <td class="paramname"><em>outStream</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [protected, pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Implemented in <a class="el" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile_1_1ShaderHelperGLSLES.html#abb0bbc0237a9965d7e6af63ad71728f6">Ogre::TerrainMaterialGeneratorA::SM2Profile::ShaderHelperGLSLES</a>, <a class="el" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile_1_1ShaderHelperGLSL.html#a68f3f6c366858cf8b582a9c76f7b3df9">Ogre::TerrainMaterialGeneratorA::SM2Profile::ShaderHelperGLSL</a>, and <a class="el" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile_1_1ShaderHelperCg.html#a4b461141ea6f5aed3ace6ca8b78d6f32">Ogre::TerrainMaterialGeneratorA::SM2Profile::ShaderHelperCg</a>.</p>

</div>
</div>
<a class="anchor" id="ab9327ddc0ae1d7123786bba0289005e7"></a><!-- doxytag: member="Ogre::TerrainMaterialGeneratorA::SM2Profile::ShaderHelper::generateFpLayer" ref="ab9327ddc0ae1d7123786bba0289005e7" args="(const SM2Profile *prof, const Terrain *terrain, TechniqueType tt, uint layer, StringUtil::StrStreamType &amp;outStream)=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile_1_1ShaderHelper.html#ab9327ddc0ae1d7123786bba0289005e7">Ogre::TerrainMaterialGeneratorA::SM2Profile::ShaderHelper::generateFpLayer</a> </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile.html">SM2Profile</a> *&#160;</td>
          <td class="paramname"><em>prof</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1Terrain.html">Terrain</a> *&#160;</td>
          <td class="paramname"><em>terrain</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile.html#a626162178bf4831bcdc1a5138e5772c6">TechniqueType</a>&#160;</td>
          <td class="paramname"><em>tt</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="namespaceOgre.html#ab6e842a18caf062ed73a5d3badd0dd4c">uint</a>&#160;</td>
          <td class="paramname"><em>layer</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="classOgre_1_1StringUtil.html#a665d79932d54b48b83acff563de7a9e5">StringUtil::StrStreamType</a> &amp;&#160;</td>
          <td class="paramname"><em>outStream</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [protected, pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Implemented in <a class="el" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile_1_1ShaderHelperGLSLES.html#a23224df675ca0684963d6a03bba9787b">Ogre::TerrainMaterialGeneratorA::SM2Profile::ShaderHelperGLSLES</a>, <a class="el" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile_1_1ShaderHelperGLSL.html#abfecfbe202c996226a28ab1c576b0dd0">Ogre::TerrainMaterialGeneratorA::SM2Profile::ShaderHelperGLSL</a>, and <a class="el" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile_1_1ShaderHelperCg.html#aab1a08528a3f52bff19a4b61b1659e42">Ogre::TerrainMaterialGeneratorA::SM2Profile::ShaderHelperCg</a>.</p>

</div>
</div>
<a class="anchor" id="a2d7a0d872046ca6724f02e1262b70b73"></a><!-- doxytag: member="Ogre::TerrainMaterialGeneratorA::SM2Profile::ShaderHelper::generateFragmentProgram" ref="a2d7a0d872046ca6724f02e1262b70b73" args="(const SM2Profile *prof, const Terrain *terrain, TechniqueType tt)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual <a class="el" href="classOgre_1_1HighLevelGpuProgramPtr.html">HighLevelGpuProgramPtr</a> <a class="el" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile_1_1ShaderHelper.html#a2d7a0d872046ca6724f02e1262b70b73">Ogre::TerrainMaterialGeneratorA::SM2Profile::ShaderHelper::generateFragmentProgram</a> </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile.html">SM2Profile</a> *&#160;</td>
          <td class="paramname"><em>prof</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1Terrain.html">Terrain</a> *&#160;</td>
          <td class="paramname"><em>terrain</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile.html#a626162178bf4831bcdc1a5138e5772c6">TechniqueType</a>&#160;</td>
          <td class="paramname"><em>tt</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

</div>
</div>
<a class="anchor" id="a051a9e289d9483f70bea14ea9d14641a"></a><!-- doxytag: member="Ogre::TerrainMaterialGeneratorA::SM2Profile::ShaderHelper::generateFragmentProgramSource" ref="a051a9e289d9483f70bea14ea9d14641a" args="(const SM2Profile *prof, const Terrain *terrain, TechniqueType tt, StringUtil::StrStreamType &amp;outStream)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile_1_1ShaderHelper.html#a051a9e289d9483f70bea14ea9d14641a">Ogre::TerrainMaterialGeneratorA::SM2Profile::ShaderHelper::generateFragmentProgramSource</a> </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile.html">SM2Profile</a> *&#160;</td>
          <td class="paramname"><em>prof</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1Terrain.html">Terrain</a> *&#160;</td>
          <td class="paramname"><em>terrain</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile.html#a626162178bf4831bcdc1a5138e5772c6">TechniqueType</a>&#160;</td>
          <td class="paramname"><em>tt</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="classOgre_1_1StringUtil.html#a665d79932d54b48b83acff563de7a9e5">StringUtil::StrStreamType</a> &amp;&#160;</td>
          <td class="paramname"><em>outStream</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [protected, virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

</div>
</div>
<a class="anchor" id="a5b6c717ef1de61420e09f8672d8ff7b1"></a><!-- doxytag: member="Ogre::TerrainMaterialGeneratorA::SM2Profile::ShaderHelper::generateVertexProgram" ref="a5b6c717ef1de61420e09f8672d8ff7b1" args="(const SM2Profile *prof, const Terrain *terrain, TechniqueType tt)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual <a class="el" href="classOgre_1_1HighLevelGpuProgramPtr.html">HighLevelGpuProgramPtr</a> <a class="el" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile_1_1ShaderHelper.html#a5b6c717ef1de61420e09f8672d8ff7b1">Ogre::TerrainMaterialGeneratorA::SM2Profile::ShaderHelper::generateVertexProgram</a> </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile.html">SM2Profile</a> *&#160;</td>
          <td class="paramname"><em>prof</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1Terrain.html">Terrain</a> *&#160;</td>
          <td class="paramname"><em>terrain</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile.html#a626162178bf4831bcdc1a5138e5772c6">TechniqueType</a>&#160;</td>
          <td class="paramname"><em>tt</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

</div>
</div>
<a class="anchor" id="adb93f316855750ce168edd01085c407b"></a><!-- doxytag: member="Ogre::TerrainMaterialGeneratorA::SM2Profile::ShaderHelper::generateVertexProgramSource" ref="adb93f316855750ce168edd01085c407b" args="(const SM2Profile *prof, const Terrain *terrain, TechniqueType tt, StringUtil::StrStreamType &amp;outStream)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile_1_1ShaderHelper.html#adb93f316855750ce168edd01085c407b">Ogre::TerrainMaterialGeneratorA::SM2Profile::ShaderHelper::generateVertexProgramSource</a> </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile.html">SM2Profile</a> *&#160;</td>
          <td class="paramname"><em>prof</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1Terrain.html">Terrain</a> *&#160;</td>
          <td class="paramname"><em>terrain</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile.html#a626162178bf4831bcdc1a5138e5772c6">TechniqueType</a>&#160;</td>
          <td class="paramname"><em>tt</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="classOgre_1_1StringUtil.html#a665d79932d54b48b83acff563de7a9e5">StringUtil::StrStreamType</a> &amp;&#160;</td>
          <td class="paramname"><em>outStream</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [protected, virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

</div>
</div>
<a class="anchor" id="a603958e286a7416fe331b48b835984db"></a><!-- doxytag: member="Ogre::TerrainMaterialGeneratorA::SM2Profile::ShaderHelper::generateVpFooter" ref="a603958e286a7416fe331b48b835984db" args="(const SM2Profile *prof, const Terrain *terrain, TechniqueType tt, StringUtil::StrStreamType &amp;outStream)=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile_1_1ShaderHelper.html#a603958e286a7416fe331b48b835984db">Ogre::TerrainMaterialGeneratorA::SM2Profile::ShaderHelper::generateVpFooter</a> </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile.html">SM2Profile</a> *&#160;</td>
          <td class="paramname"><em>prof</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1Terrain.html">Terrain</a> *&#160;</td>
          <td class="paramname"><em>terrain</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile.html#a626162178bf4831bcdc1a5138e5772c6">TechniqueType</a>&#160;</td>
          <td class="paramname"><em>tt</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="classOgre_1_1StringUtil.html#a665d79932d54b48b83acff563de7a9e5">StringUtil::StrStreamType</a> &amp;&#160;</td>
          <td class="paramname"><em>outStream</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [protected, pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Implemented in <a class="el" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile_1_1ShaderHelperGLSLES.html#a86bc10c0a63dc6ea355afd7f81e70537">Ogre::TerrainMaterialGeneratorA::SM2Profile::ShaderHelperGLSLES</a>, <a class="el" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile_1_1ShaderHelperGLSL.html#a910ef39e1781038f2f54369b4d80d6b4">Ogre::TerrainMaterialGeneratorA::SM2Profile::ShaderHelperGLSL</a>, and <a class="el" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile_1_1ShaderHelperCg.html#af00aef34f40f37613c04e97b0c7690d8">Ogre::TerrainMaterialGeneratorA::SM2Profile::ShaderHelperCg</a>.</p>

</div>
</div>
<a class="anchor" id="a8592db72e31a98936f251b2d4bc8b107"></a><!-- doxytag: member="Ogre::TerrainMaterialGeneratorA::SM2Profile::ShaderHelper::generateVpHeader" ref="a8592db72e31a98936f251b2d4bc8b107" args="(const SM2Profile *prof, const Terrain *terrain, TechniqueType tt, StringUtil::StrStreamType &amp;outStream)=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile_1_1ShaderHelper.html#a8592db72e31a98936f251b2d4bc8b107">Ogre::TerrainMaterialGeneratorA::SM2Profile::ShaderHelper::generateVpHeader</a> </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile.html">SM2Profile</a> *&#160;</td>
          <td class="paramname"><em>prof</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1Terrain.html">Terrain</a> *&#160;</td>
          <td class="paramname"><em>terrain</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile.html#a626162178bf4831bcdc1a5138e5772c6">TechniqueType</a>&#160;</td>
          <td class="paramname"><em>tt</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="classOgre_1_1StringUtil.html#a665d79932d54b48b83acff563de7a9e5">StringUtil::StrStreamType</a> &amp;&#160;</td>
          <td class="paramname"><em>outStream</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [protected, pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Implemented in <a class="el" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile_1_1ShaderHelperGLSLES.html#a18e1833c0535e51eb79999193b779bed">Ogre::TerrainMaterialGeneratorA::SM2Profile::ShaderHelperGLSLES</a>, <a class="el" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile_1_1ShaderHelperGLSL.html#a3d51b17533918821cb4e8956f8512001">Ogre::TerrainMaterialGeneratorA::SM2Profile::ShaderHelperGLSL</a>, and <a class="el" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile_1_1ShaderHelperCg.html#a1b2a24edb873b37d1633646e5d317275">Ogre::TerrainMaterialGeneratorA::SM2Profile::ShaderHelperCg</a>.</p>

</div>
</div>
<a class="anchor" id="a05053b390eb85adeb67b2f5e231fb757"></a><!-- doxytag: member="Ogre::TerrainMaterialGeneratorA::SM2Profile::ShaderHelper::generateVpLayer" ref="a05053b390eb85adeb67b2f5e231fb757" args="(const SM2Profile *prof, const Terrain *terrain, TechniqueType tt, uint layer, StringUtil::StrStreamType &amp;outStream)=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile_1_1ShaderHelper.html#a05053b390eb85adeb67b2f5e231fb757">Ogre::TerrainMaterialGeneratorA::SM2Profile::ShaderHelper::generateVpLayer</a> </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile.html">SM2Profile</a> *&#160;</td>
          <td class="paramname"><em>prof</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1Terrain.html">Terrain</a> *&#160;</td>
          <td class="paramname"><em>terrain</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile.html#a626162178bf4831bcdc1a5138e5772c6">TechniqueType</a>&#160;</td>
          <td class="paramname"><em>tt</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="namespaceOgre.html#ab6e842a18caf062ed73a5d3badd0dd4c">uint</a>&#160;</td>
          <td class="paramname"><em>layer</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="classOgre_1_1StringUtil.html#a665d79932d54b48b83acff563de7a9e5">StringUtil::StrStreamType</a> &amp;&#160;</td>
          <td class="paramname"><em>outStream</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [protected, pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Implemented in <a class="el" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile_1_1ShaderHelperGLSLES.html#addf9378c351fa14c7f1fdc571cdc5ad9">Ogre::TerrainMaterialGeneratorA::SM2Profile::ShaderHelperGLSLES</a>, <a class="el" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile_1_1ShaderHelperGLSL.html#a87416982cb2fbd8c558ef9bf538085d7">Ogre::TerrainMaterialGeneratorA::SM2Profile::ShaderHelperGLSL</a>, and <a class="el" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile_1_1ShaderHelperCg.html#ae14ba750b4bde5ae4f3f75fb47163a07">Ogre::TerrainMaterialGeneratorA::SM2Profile::ShaderHelperCg</a>.</p>

</div>
</div>
<a class="anchor" id="abe43c3f90310fb32c71bc6d53458e405"></a><!-- doxytag: member="Ogre::TerrainMaterialGeneratorA::SM2Profile::ShaderHelper::getChannel" ref="abe43c3f90310fb32c71bc6d53458e405" args="(uint idx)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">static <a class="el" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> <a class="el" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile_1_1ShaderHelper.html#abe43c3f90310fb32c71bc6d53458e405">Ogre::TerrainMaterialGeneratorA::SM2Profile::ShaderHelper::getChannel</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="namespaceOgre.html#ab6e842a18caf062ed73a5d3badd0dd4c">uint</a>&#160;</td>
          <td class="paramname"><em>idx</em></td><td>)</td>
          <td><code> [static, protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

</div>
</div>
<a class="anchor" id="a51da01d67dd1583b065aedb8f490a77f"></a><!-- doxytag: member="Ogre::TerrainMaterialGeneratorA::SM2Profile::ShaderHelper::getFragmentProgramName" ref="a51da01d67dd1583b065aedb8f490a77f" args="(const SM2Profile *prof, const Terrain *terrain, TechniqueType tt)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual <a class="el" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> <a class="el" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile_1_1ShaderHelper.html#a51da01d67dd1583b065aedb8f490a77f">Ogre::TerrainMaterialGeneratorA::SM2Profile::ShaderHelper::getFragmentProgramName</a> </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile.html">SM2Profile</a> *&#160;</td>
          <td class="paramname"><em>prof</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1Terrain.html">Terrain</a> *&#160;</td>
          <td class="paramname"><em>terrain</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile.html#a626162178bf4831bcdc1a5138e5772c6">TechniqueType</a>&#160;</td>
          <td class="paramname"><em>tt</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [protected, virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

</div>
</div>
<a class="anchor" id="a7766b57d1f02d8678a3c3157c48f8125"></a><!-- doxytag: member="Ogre::TerrainMaterialGeneratorA::SM2Profile::ShaderHelper::getVertexProgramName" ref="a7766b57d1f02d8678a3c3157c48f8125" args="(const SM2Profile *prof, const Terrain *terrain, TechniqueType tt)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual <a class="el" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> <a class="el" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile_1_1ShaderHelper.html#a7766b57d1f02d8678a3c3157c48f8125">Ogre::TerrainMaterialGeneratorA::SM2Profile::ShaderHelper::getVertexProgramName</a> </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile.html">SM2Profile</a> *&#160;</td>
          <td class="paramname"><em>prof</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1Terrain.html">Terrain</a> *&#160;</td>
          <td class="paramname"><em>terrain</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile.html#a626162178bf4831bcdc1a5138e5772c6">TechniqueType</a>&#160;</td>
          <td class="paramname"><em>tt</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [protected, virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

</div>
</div>
<a class="anchor" id="a8357fe4fb4849772b94baa4bf47c7ded"></a><!-- doxytag: member="Ogre::TerrainMaterialGeneratorA::SM2Profile::ShaderHelper::operator delete" ref="a8357fe4fb4849772b94baa4bf47c7ded" args="(void *ptr)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Alloc &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1AllocatedObject.html">Ogre::AllocatedObject</a>&lt; Alloc &gt;::operator delete </td>
          <td>(</td>
          <td class="paramtype">void *&#160;</td>
          <td class="paramname"><em>ptr</em></td><td>)</td>
          <td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreMemoryAllocatedObject_8h_source.html#l00095">95</a> of file <a class="el" href="OgreMemoryAllocatedObject_8h_source.html">OgreMemoryAllocatedObject.h</a>.</p>

</div>
</div>
<a class="anchor" id="a1c727e879a260c37b00ce5505fe8e144"></a><!-- doxytag: member="Ogre::TerrainMaterialGeneratorA::SM2Profile::ShaderHelper::operator delete" ref="a1c727e879a260c37b00ce5505fe8e144" args="(void *ptr, void *)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Alloc &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1AllocatedObject.html">Ogre::AllocatedObject</a>&lt; Alloc &gt;::operator delete </td>
          <td>(</td>
          <td class="paramtype">void *&#160;</td>
          <td class="paramname"><em>ptr</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">void *&#160;</td>
          <td class="paramname">&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreMemoryAllocatedObject_8h_source.html#l00101">101</a> of file <a class="el" href="OgreMemoryAllocatedObject_8h_source.html">OgreMemoryAllocatedObject.h</a>.</p>

</div>
</div>
<a class="anchor" id="acb46d4b0a597156d9ba5abc39d127792"></a><!-- doxytag: member="Ogre::TerrainMaterialGeneratorA::SM2Profile::ShaderHelper::operator delete" ref="acb46d4b0a597156d9ba5abc39d127792" args="(void *ptr, const char *, int, const char *)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Alloc &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1AllocatedObject.html">Ogre::AllocatedObject</a>&lt; Alloc &gt;::operator delete </td>
          <td>(</td>
          <td class="paramtype">void *&#160;</td>
          <td class="paramname"><em>ptr</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname">, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname">, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname">&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreMemoryAllocatedObject_8h_source.html#l00107">107</a> of file <a class="el" href="OgreMemoryAllocatedObject_8h_source.html">OgreMemoryAllocatedObject.h</a>.</p>

</div>
</div>
<a class="anchor" id="a93e6a86dde5483c053ca0f2a85bbfd6c"></a><!-- doxytag: member="Ogre::TerrainMaterialGeneratorA::SM2Profile::ShaderHelper::operator delete[]" ref="a93e6a86dde5483c053ca0f2a85bbfd6c" args="(void *ptr)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Alloc &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1AllocatedObject.html">Ogre::AllocatedObject</a>&lt; Alloc &gt;::operator delete[] </td>
          <td>(</td>
          <td class="paramtype">void *&#160;</td>
          <td class="paramname"><em>ptr</em></td><td>)</td>
          <td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreMemoryAllocatedObject_8h_source.html#l00112">112</a> of file <a class="el" href="OgreMemoryAllocatedObject_8h_source.html">OgreMemoryAllocatedObject.h</a>.</p>

</div>
</div>
<a class="anchor" id="a595ea4c05da8aa987d3800e65d23355d"></a><!-- doxytag: member="Ogre::TerrainMaterialGeneratorA::SM2Profile::ShaderHelper::operator delete[]" ref="a595ea4c05da8aa987d3800e65d23355d" args="(void *ptr, const char *, int, const char *)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Alloc &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1AllocatedObject.html">Ogre::AllocatedObject</a>&lt; Alloc &gt;::operator delete[] </td>
          <td>(</td>
          <td class="paramtype">void *&#160;</td>
          <td class="paramname"><em>ptr</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname">, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname">, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname">&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreMemoryAllocatedObject_8h_source.html#l00118">118</a> of file <a class="el" href="OgreMemoryAllocatedObject_8h_source.html">OgreMemoryAllocatedObject.h</a>.</p>

</div>
</div>
<a class="anchor" id="a421b197ca3a38da17e2eb1531a645fa2"></a><!-- doxytag: member="Ogre::TerrainMaterialGeneratorA::SM2Profile::ShaderHelper::operator new" ref="a421b197ca3a38da17e2eb1531a645fa2" args="(size_t sz, const char *file, int line, const char *func)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Alloc &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void* <a class="el" href="classOgre_1_1AllocatedObject.html">Ogre::AllocatedObject</a>&lt; Alloc &gt;::operator new </td>
          <td>(</td>
          <td class="paramtype">size_t&#160;</td>
          <td class="paramname"><em>sz</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname"><em>file</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>line</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname"><em>func</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>operator new, with debug line info </p>

<p>Definition at line <a class="el" href="OgreMemoryAllocatedObject_8h_source.html#l00067">67</a> of file <a class="el" href="OgreMemoryAllocatedObject_8h_source.html">OgreMemoryAllocatedObject.h</a>.</p>

</div>
</div>
<a class="anchor" id="ac4bdf968b7b9af8a5239a27da73d5711"></a><!-- doxytag: member="Ogre::TerrainMaterialGeneratorA::SM2Profile::ShaderHelper::operator new" ref="ac4bdf968b7b9af8a5239a27da73d5711" args="(size_t sz)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Alloc &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void* <a class="el" href="classOgre_1_1AllocatedObject.html">Ogre::AllocatedObject</a>&lt; Alloc &gt;::operator new </td>
          <td>(</td>
          <td class="paramtype">size_t&#160;</td>
          <td class="paramname"><em>sz</em></td><td>)</td>
          <td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreMemoryAllocatedObject_8h_source.html#l00072">72</a> of file <a class="el" href="OgreMemoryAllocatedObject_8h_source.html">OgreMemoryAllocatedObject.h</a>.</p>

</div>
</div>
<a class="anchor" id="ab78a921e54419be677839cdf15d1f0b8"></a><!-- doxytag: member="Ogre::TerrainMaterialGeneratorA::SM2Profile::ShaderHelper::operator new" ref="ab78a921e54419be677839cdf15d1f0b8" args="(size_t sz, void *ptr)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Alloc &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void* <a class="el" href="classOgre_1_1AllocatedObject.html">Ogre::AllocatedObject</a>&lt; Alloc &gt;::operator new </td>
          <td>(</td>
          <td class="paramtype">size_t&#160;</td>
          <td class="paramname"><em>sz</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">void *&#160;</td>
          <td class="paramname"><em>ptr</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>placement operator new </p>

<p>Definition at line <a class="el" href="OgreMemoryAllocatedObject_8h_source.html#l00078">78</a> of file <a class="el" href="OgreMemoryAllocatedObject_8h_source.html">OgreMemoryAllocatedObject.h</a>.</p>

</div>
</div>
<a class="anchor" id="a4be37baef81876985aa1071ad5acc6dd"></a><!-- doxytag: member="Ogre::TerrainMaterialGeneratorA::SM2Profile::ShaderHelper::operator new[]" ref="a4be37baef81876985aa1071ad5acc6dd" args="(size_t sz, const char *file, int line, const char *func)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Alloc &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void* <a class="el" href="classOgre_1_1AllocatedObject.html">Ogre::AllocatedObject</a>&lt; Alloc &gt;::operator new[] </td>
          <td>(</td>
          <td class="paramtype">size_t&#160;</td>
          <td class="paramname"><em>sz</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname"><em>file</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>line</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname"><em>func</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>array operator new, with debug line info </p>

<p>Definition at line <a class="el" href="OgreMemoryAllocatedObject_8h_source.html#l00085">85</a> of file <a class="el" href="OgreMemoryAllocatedObject_8h_source.html">OgreMemoryAllocatedObject.h</a>.</p>

</div>
</div>
<a class="anchor" id="afa2943846ba6a2b5824a12857139cf5e"></a><!-- doxytag: member="Ogre::TerrainMaterialGeneratorA::SM2Profile::ShaderHelper::operator new[]" ref="afa2943846ba6a2b5824a12857139cf5e" args="(size_t sz)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Alloc &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void* <a class="el" href="classOgre_1_1AllocatedObject.html">Ogre::AllocatedObject</a>&lt; Alloc &gt;::operator new[] </td>
          <td>(</td>
          <td class="paramtype">size_t&#160;</td>
          <td class="paramname"><em>sz</em></td><td>)</td>
          <td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreMemoryAllocatedObject_8h_source.html#l00090">90</a> of file <a class="el" href="OgreMemoryAllocatedObject_8h_source.html">OgreMemoryAllocatedObject.h</a>.</p>

</div>
</div>
<a class="anchor" id="a85c467fe1d437ab15d8ab52a7b7b1a4f"></a><!-- doxytag: member="Ogre::TerrainMaterialGeneratorA::SM2Profile::ShaderHelper::updateFpParams" ref="a85c467fe1d437ab15d8ab52a7b7b1a4f" args="(const SM2Profile *prof, const Terrain *terrain, TechniqueType tt, const GpuProgramParametersSharedPtr &amp;params)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile_1_1ShaderHelper.html#a85c467fe1d437ab15d8ab52a7b7b1a4f">Ogre::TerrainMaterialGeneratorA::SM2Profile::ShaderHelper::updateFpParams</a> </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile.html">SM2Profile</a> *&#160;</td>
          <td class="paramname"><em>prof</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1Terrain.html">Terrain</a> *&#160;</td>
          <td class="paramname"><em>terrain</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile.html#a626162178bf4831bcdc1a5138e5772c6">TechniqueType</a>&#160;</td>
          <td class="paramname"><em>tt</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="group__Materials.html#gaebab7cecf3f3ae81a1fbfa08ab36f2b5">GpuProgramParametersSharedPtr</a> &amp;&#160;</td>
          <td class="paramname"><em>params</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [protected, virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

</div>
</div>
<a class="anchor" id="a89278834abece5ce1bf66a0b7ecc9f05"></a><!-- doxytag: member="Ogre::TerrainMaterialGeneratorA::SM2Profile::ShaderHelper::updateParams" ref="a89278834abece5ce1bf66a0b7ecc9f05" args="(const SM2Profile *prof, const MaterialPtr &amp;mat, const Terrain *terrain, bool compositeMap)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile_1_1ShaderHelper.html#a89278834abece5ce1bf66a0b7ecc9f05">Ogre::TerrainMaterialGeneratorA::SM2Profile::ShaderHelper::updateParams</a> </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile.html">SM2Profile</a> *&#160;</td>
          <td class="paramname"><em>prof</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1MaterialPtr.html">MaterialPtr</a> &amp;&#160;</td>
          <td class="paramname"><em>mat</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1Terrain.html">Terrain</a> *&#160;</td>
          <td class="paramname"><em>terrain</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">bool&#160;</td>
          <td class="paramname"><em>compositeMap</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

</div>
</div>
<a class="anchor" id="a424cd62f696d63da60cea51f03579e84"></a><!-- doxytag: member="Ogre::TerrainMaterialGeneratorA::SM2Profile::ShaderHelper::updateVpParams" ref="a424cd62f696d63da60cea51f03579e84" args="(const SM2Profile *prof, const Terrain *terrain, TechniqueType tt, const GpuProgramParametersSharedPtr &amp;params)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile_1_1ShaderHelper.html#a424cd62f696d63da60cea51f03579e84">Ogre::TerrainMaterialGeneratorA::SM2Profile::ShaderHelper::updateVpParams</a> </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile.html">SM2Profile</a> *&#160;</td>
          <td class="paramname"><em>prof</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1Terrain.html">Terrain</a> *&#160;</td>
          <td class="paramname"><em>terrain</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile.html#a626162178bf4831bcdc1a5138e5772c6">TechniqueType</a>&#160;</td>
          <td class="paramname"><em>tt</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="group__Materials.html#gaebab7cecf3f3ae81a1fbfa08ab36f2b5">GpuProgramParametersSharedPtr</a> &amp;&#160;</td>
          <td class="paramname"><em>params</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [protected, virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

</div>
</div>
<hr/><h2>Member Data Documentation</h2>
<a class="anchor" id="a517f480f42d873878c2ffe3ef464afb7"></a><!-- doxytag: member="Ogre::TerrainMaterialGeneratorA::SM2Profile::ShaderHelper::mShadowSamplerStartHi" ref="a517f480f42d873878c2ffe3ef464afb7" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">size_t <a class="el" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile_1_1ShaderHelper.html#a517f480f42d873878c2ffe3ef464afb7">Ogre::TerrainMaterialGeneratorA::SM2Profile::ShaderHelper::mShadowSamplerStartHi</a><code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreTerrainMaterialGeneratorA_8h_source.html#l00188">188</a> of file <a class="el" href="OgreTerrainMaterialGeneratorA_8h_source.html">OgreTerrainMaterialGeneratorA.h</a>.</p>

</div>
</div>
<a class="anchor" id="adf1108ee4e3b76d105732210ccf4ff51"></a><!-- doxytag: member="Ogre::TerrainMaterialGeneratorA::SM2Profile::ShaderHelper::mShadowSamplerStartLo" ref="adf1108ee4e3b76d105732210ccf4ff51" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">size_t <a class="el" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile_1_1ShaderHelper.html#adf1108ee4e3b76d105732210ccf4ff51">Ogre::TerrainMaterialGeneratorA::SM2Profile::ShaderHelper::mShadowSamplerStartLo</a><code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreTerrainMaterialGeneratorA_8h_source.html#l00189">189</a> of file <a class="el" href="OgreTerrainMaterialGeneratorA_8h_source.html">OgreTerrainMaterialGeneratorA.h</a>.</p>

</div>
</div>
<hr/>The documentation for this class was generated from the following file:<ul>
<li><a class="el" href="OgreTerrainMaterialGeneratorA_8h_source.html">OgreTerrainMaterialGeneratorA.h</a></li>
</ul>
</div><!-- contents -->
<hr>
<p>
Copyright &copy; 2012 Torus Knot Software Ltd<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-ShareAlike 3.0 Unported License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Fri May 25 2012 21:49:12
</p>
</body>
</html>
